package com.moyoung.moyoung_ble_plugin.event;

import com.crrepa.ble.conn.CRPBleConnection;
import com.crrepa.ble.conn.bean.CRPStepInfo;
import com.crrepa.ble.conn.listener.CRPStepChangeListener;
import com.crrepa.ble.conn.type.CRPHistoryDay;
import com.moyoung.moyoung_ble_plugin.base.BaseConnectionEventChannelHandler;
import com.moyoung.moyoung_ble_plugin.common.GsonUtils;
import com.moyoung.moyoung_ble_plugin.model.StepsChangeBean;

import io.flutter.plugin.common.MethodCall;

public class StepsChangeHandler extends BaseConnectionEventChannelHandler {
    @Override
    public void setConnListener(CRPBleConnection connection, MethodCall call) {
        connection.setStepChangeListener(new CRPStepChangeListener() {
            @Override
            public void onStepChange(CRPStepInfo crpStepInfo) {
                if (eventSink == null) {
                    return;
                }
                StepsChangeBean stepsChangeBean = new StepsChangeBean();
                stepsChangeBean.setTimeType(StepsChangeBean.TODAY_STEPS);
                stepsChangeBean.setStepsInfo(crpStepInfo);
                String stepsStr = GsonUtils.get().toJson(stepsChangeBean, StepsChangeBean.class);
                activity.runOnUiThread(() -> eventSink.success(stepsStr));
            }

            @Override
            public void onHistoryStepChange(CRPHistoryDay historyDay, CRPStepInfo stepInfo) {
                if (eventSink == null) {
                    return;
                }
                StepsChangeBean stepChangeBean = new StepsChangeBean();
                stepChangeBean.setHistoryDay(historyDay);
                stepChangeBean.setStepsInfo(stepInfo);
                String stepsStr = GsonUtils.get().toJson(stepChangeBean, StepsChangeBean.class);
                activity.runOnUiThread(() -> eventSink.success(stepsStr));
            }

//            @Override
//            public void onPastStepChange(int past, CRPStepInfo historyStepsInfo) {
//                if (eventSink == null) {
//                    return;
//                }
//                StepsChangeBean stepChangeBean = new StepsChangeBean();
//                stepChangeBean.setTimeType(past);
//                stepChangeBean.setStepsInfo(historyStepsInfo);
//                String stepsStr = GsonUtils.get().toJson(stepChangeBean, StepsChangeBean.class);
//                activity.runOnUiThread(() -> eventSink.success(stepsStr));
//            }
        });
    }

}
